package org.gstreamer.encoding;

import org.gstreamer.Caps;

/**
 * Variant of GstEncodingProfile for audio streams.
 */
public class EncodingAudioProfile extends EncodingProfile {
    public static final String GTYPE_NAME = "GstEncodingAudioProfile";

    public EncodingAudioProfile(Initializer init) {
        super(init);
    }

    /**
     * gst_encoding_audio_profile_new ()
     *
     * GstEncodingAudioProfile * gst_encoding_audio_profile_new (GstCaps
     * *format, const gchar *preset, GstCaps *restriction, guint presence);
     *
     * Creates a new GstEncodingAudioProfile
     *
     * All provided allocatable arguments will be internally copied, so can be
     * safely freed/unreferenced after calling this method. Parameters
     *
     * format
     *
     *
     * the GstCaps
     *
     *
     * preset
     *
     *
     * the preset(s) to use on the encoder, can be NULL. [allow-none]
     *
     * restriction
     *
     *
     * the GstCaps used to restrict the input to the encoder, can be NULL. See
     * gst_encoding_profile_get_restriction() for more details. [allow-none]
     *
     * presence
     *
     *
     * the number of time this stream must be used. 0 means any number of times
     * (including never)
     *
     * Returns
     *
     * the newly created GstEncodingAudioProfile. gst_encoding_video_profile_new
     * ()
     */

    public EncodingAudioProfile(Caps format, String preset, Caps restriction, int presence) {
        this(initializer(gst.ptr_gst_encoding_audio_profile_new(format, preset, restriction, presence), false, true));
    }

}
