package org.gstreamer.ges;

import org.gstreamer.lowlevel.IntegerEnum;

/**
 * enum GESPipelineFlags
 *
 * The various modes the GESPipeline can be configured to. *
 */
public enum GESPipelineFlags implements IntegerEnum {

    /** output audio to the soundcard */
    MODE_PREVIEW_AUDIO(1<<0),
    /** output video to the screen */
    MODE_PREVIEW_VIDEO(1<<1),

    /** output audio/video to soundcard/screen (default) */
    MODE_PREVIEW(MODE_PREVIEW_AUDIO.intValue() | MODE_PREVIEW_VIDEO.intValue()),

    /** render timeline (forces decoding) */
    MODE_RENDER (1<<2),

    /** render timeline (tries to avoid decoding/reencoding) */
    MODE_SMART_RENDER(1 << 3);

    int value;

    GESPipelineFlags(int value) {
        this.value = value;
    }

    @Override
    public int intValue() {
        return value;
    }


}
