package org.gstreamer.ges;

import org.gstreamer.ClockTime;
import org.gstreamer.GObject;
import org.gstreamer.lowlevel.GESTimelineElementAPI;

public class GESTimelineElement extends GObject {
    public static final String GTYPE_NAME = "GESTimelineElement";

    private static final GESTimelineElementAPI ges = GESTimelineElementAPI.GESTIMELINELEMENT_API;

    public GESTimelineElement(Initializer init) {
        super(init);
    }

    public void setDuration(ClockTime duration) {
        ges.ges_timeline_element_set_duration(this, duration);
    }

    public void setInpoint(ClockTime inpoint) {
        ges.ges_timeline_element_set_inpoint(this, inpoint);
    }

    public void setStart(ClockTime start) {
        ges.ges_timeline_element_set_start(this, start);
    }

    public ClockTime getDuration() {
        return ges.ges_timeline_element_get_duration(this);
    }

    public ClockTime getInpoint() {
        return ges.ges_timeline_element_get_inpoint(this);
    }

    public ClockTime getStart() {
        return ges.ges_timeline_element_get_start(this);
    }

    public void setPriority(int priority) {
        ges.ges_timeline_element_set_priority(this, priority);
    }

    public int getPriority() {
        return ges.ges_timeline_element_get_priority(this);
    }
}
