package org.gstreamer.ges.clip;

import org.gstreamer.lowlevel.GESEffectClipAPI;

public class GESEffectClip extends GESBaseEffectClip {
    public static final String GTYPE_NAME = "GESEffectClip";
    private static final GESEffectClipAPI ges = GESEffectClipAPI.GSTEFFECTCLIP_API;

    public GESEffectClip(Initializer init) {
        super(init);
    }

    /**
     * Creates a new GESEffectClip from the description of the bin. Parameters
     *
     * video_bin_description
     *
     *
     * The gst-launch like bin description of the effect
     *
     *
     * audio_bin_description
     *
     *
     * The gst-launch like bin description of the effect
     *
     * Returns
     *
     * a newly created GESEffectClip, or NULL if something went wrong.
     */

    public GESEffectClip(String videoBinDescription, String audioBinDescription) {
        this(initializer(ges.ptr_ges_effect_clip_new(videoBinDescription, audioBinDescription), false, true));
    }
}
