package org.gstreamer.ges.source;

/**
 * GESVideoSource
 *
 * GESVideoSource — Base Class for video sources
 *
 * Description Children Properties
 *
 * You can use the following children properties through the
 * ges_track_element_set_child_property and alike set of methods:
 *
 * double alpha The desired alpha for the stream.
 *
 * gint posx The desired x position for the stream.
 *
 * gint posy The desired y position for the stream
 *
 * guint zorder The desired z order for the stream
 *
 * gint width The desired width for that source. Set to 0 if size is not
 * mandatory, will be set to width of the current track.
 *
 * gint height The desired height for that source. Set to 0 if size is not
 * mandatory, will be set to height of the current track.
 *
 * Types and Values GESVideoSource
 *
 * typedef struct _GESVideoSource GESVideoSource;
 *
 * Base class for video sources
 */
public class GESVideoSource extends GESSource {
    public static final String GTYPE_NAME = "GESVideoSource";

    public GESVideoSource(Initializer init) {
        super(init);
    }

}
