package org.gstreamer.lowlevel;

import org.gstreamer.ges.GESAsset;
import org.gstreamer.ges.GESLayer;
import org.gstreamer.ges.GESTrack;
import org.gstreamer.ges.GESTrackElement;
import org.gstreamer.ges.GESTrackType;
import org.gstreamer.ges.clip.GESClip;
import org.gstreamer.ges.operation.GESBaseEffect;
import org.gstreamer.lowlevel.GlibAPI.GList;

public interface GESClipAPI extends com.sun.jna.Library {
    static GESClipAPI GSTCLIP_API = GstNative.load("ges", GESClipAPI.class);

    GESLayer ges_clip_get_layer(GESClip clip);

    GESTrackElement ges_clip_find_track_element(GESClip clip, GESTrack track, GType type);

    GList ges_clip_find_track_elements(GESClip clip, GESTrack track, GESTrackType track_type, GType type);

    GESTrackElement ges_clip_add_asset(GESClip clip, GESAsset asset);

    GList ges_clip_get_top_effects(GESClip clip);

    int ges_clip_get_top_effect_index(GESClip clip, GESBaseEffect effect);

    boolean ges_clip_move_to_layer(GESClip clip, GESLayer layer);

    boolean ges_clip_set_top_effect_index(GESClip clip, GESBaseEffect effect, int newindex);

    void ges_clip_set_supported_formats(GESClip clip, GESTrackType supportedformats);

    int ges_clip_get_supported_formats(GESClip clip);

    GESClip ges_clip_split(GESClip clip, long position);
}
