package org.gstreamer.lowlevel;

import org.gstreamer.ClockTime;
import org.gstreamer.ges.GESAsset;
import org.gstreamer.ges.GESLayer;
import org.gstreamer.ges.GESTimeline;
import org.gstreamer.ges.clip.GESClip;
import org.gstreamer.lowlevel.GlibAPI.GList;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Library;
import com.sun.jna.Pointer;


public interface GESLayerAPI extends Library {
    static final GESLayerAPI ges = GstNative.load("ges", GESLayerAPI.class);

    boolean ges_layer_add_clip(GESLayer layer, GESClip clip);

    GESClip ges_layer_add_asset(GESLayer layer, GESAsset asset, ClockTime start, ClockTime inpoint, ClockTime duration,
            int track_types);

    @CallerOwnsReturn
    Pointer ptr_ges_layer_new();
    GESLayer ges_layer_new();

    boolean ges_layer_remove_clip(GESLayer layer, GESClip clip);

    void ges_layer_set_priority(GESLayer layer, int priority);

    int ges_layer_get_priority(GESLayer layer);

    GList ges_layer_get_clips(GESLayer layer);

    GESTimeline ges_layer_get_timeline(GESLayer layer);

    boolean ges_layer_get_auto_transition(GESLayer layer);

    void ges_layer_set_auto_transition(GESLayer layer, boolean auto_transition);

    boolean ges_layer_is_empty(GESLayer layer);

    ClockTime ges_layer_get_duration(GESLayer layer);
}
