
package org.gstreamer.lowlevel;

import org.gstreamer.Caps;
import org.gstreamer.Element;
import org.gstreamer.Sample;
import org.gstreamer.encoding.EncodingProfile;
import org.gstreamer.ges.GESPipeline;
import org.gstreamer.ges.GESTimeline;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Pointer;

/**
 * GstPipeline
 */
public interface GESPipelineAPI extends com.sun.jna.Library {

    @CallerOwnsReturn
    GESPipeline ges_pipeline_new();

    boolean ges_pipeline_set_timeline(GESPipeline pipeline, GESTimeline timeline);

    boolean ges_pipeline_set_mode(GESPipeline pipeline, int mode);

    boolean ges_pipeline_set_render_settings(GESPipeline pipeline,
            String output_uri,
            EncodingProfile profile);

    Element ges_pipeline_preview_get_audio_sink(GESPipeline self);

    Element ges_pipeline_preview_get_video_sink(GESPipeline self);

    void ges_pipeline_preview_set_audio_sink(GESPipeline self, Element sink);

    void ges_pipeline_preview_set_video_sink(GESPipeline self, Element sink);

    int ges_pipeline_get_mode(GESPipeline self);

    Sample ges_pipeline_get_thumbnail(GESPipeline self, Caps caps);

    Sample ges_pipeline_get_thumbnail_rgb24(GESPipeline self,
            int width,
            int height);

    boolean
    ges_pipeline_save_thumbnail (GESPipeline self,
                                 int width,
                                 int height,
                                 String format,
            String location, Pointer[] error);
}
