package org.gstreamer.lowlevel;

import org.gstreamer.ges.GESVideoStandardTransitionType;
import org.gstreamer.ges.clip.GESTextOverlayClip;
import org.gstreamer.ges.clip.GESTextOverlayClip.GESTextHAlign;
import org.gstreamer.ges.clip.GESTextOverlayClip.GESTextVAlign;
import org.gstreamer.ges.operation.GESVideoTransition;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Library;
import com.sun.jna.Pointer;

public interface GESTextOverlayClipAPI extends Library {
    static GESTextOverlayClipAPI GESTEXTOVERLAYCLIP_API = GstNative.load("ges", GESTextOverlayClipAPI.class);
    
    @CallerOwnsReturn
    Pointer ptr_ges_text_overlay_clip_new ();

    @CallerOwnsReturn
    GESTextOverlayClip ges_text_overlay_clip_new (); 

    void ges_text_overlay_clip_set_text (GESTextOverlayClip self,String text);

    void ges_text_overlay_clip_set_font_desc (GESTextOverlayClip self, String font_desc);
 
    void ges_text_overlay_clip_set_valign (GESTextOverlayClip self,GESTextVAlign valign);

    void ges_text_overlay_clip_set_halign (GESTextOverlayClip self,GESTextHAlign halign);
    
    void ges_text_overlay_clip_set_color (GESTextOverlayClip self,int color);
    
    void ges_text_overlay_clip_set_xpos (GESTextOverlayClip self, double position);
    
    void ges_text_overlay_clip_set_ypos (GESTextOverlayClip self, double position);
    
    String ges_text_overlay_clip_get_text (GESTextOverlayClip self);
    
    String ges_text_overlay_clip_get_font_desc (GESTextOverlayClip self);
    
    GESTextVAlign ges_text_overlay_clip_get_valignment (GESTextOverlayClip self);
     
    GESTextHAlign ges_text_overlay_clip_get_halignment (GESTextOverlayClip self); 
    
    int ges_text_overlay_clip_get_color (GESTextOverlayClip self);
    
    double ges_text_overlay_clip_get_xpos (GESTextOverlayClip self);
    
    double ges_text_overlay_clip_get_ypos (GESTextOverlayClip self);
}
