package org.gstreamer.lowlevel;

import org.gstreamer.ClockTime;
import org.gstreamer.Pad;
import org.gstreamer.ges.GESAsset;
import org.gstreamer.ges.GESLayer;
import org.gstreamer.ges.GESTimeline;
import org.gstreamer.ges.GESTimelineElement;
import org.gstreamer.ges.GESTrack;
import org.gstreamer.lowlevel.GlibAPI.GList;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Pointer;

/**
 * GstPipeline
 */
public interface GESTimelineAPI extends com.sun.jna.Library {

    static GESTimelineAPI GESTIMELINE_API = GstNative.load("ges", GESTimelineAPI.class);

    @CallerOwnsReturn
    Pointer ptr_ges_timeline_new();
    @CallerOwnsReturn
    GESTimeline ges_timeline_new();

    @CallerOwnsReturn
    Pointer ptr_ges_timeline_new_audio_video();
    @CallerOwnsReturn
    GESTimeline ges_timeline_new_audio_video();

    @CallerOwnsReturn
    Pointer ptr_ges_timeline_new_from_uri(String uri, Pointer[] error);
    @CallerOwnsReturn
    GESTimeline ges_timeline_new_from_uri(String uri, Pointer[] error);

    boolean ges_timeline_add_layer(GESTimeline timeline, GESLayer layer);

    @CallerOwnsReturn
    Pointer ptr_ges_timeline_append_layer(GESTimeline timeline);

    @CallerOwnsReturn
    GESLayer ges_timeline_append_layer(GESTimeline timeline);

    boolean ges_timeline_remove_layer(GESTimeline timeline, GESLayer layer);

    boolean ges_timeline_add_track(GESTimeline timeline, GESTrack track);

    boolean ges_timeline_remove_track(GESTimeline timeline, GESTrack track);

    boolean ges_timeline_load_from_uri(GESTimeline timeline, String uri, Pointer[] error);

    boolean ges_timeline_save_to_uri(GESTimeline timeline, String uri, GESAsset formatter_asset, boolean overwrite,
            Pointer[] error);

    boolean ges_timeline_commit(GESTimeline timeline);

    boolean ges_timeline_commit_sync(GESTimeline timeline);

    GList ges_timeline_get_tracks(GESTimeline timeline);

    GESLayer ges_timeline_get_layer(GESTimeline timeline,
            int priority);

    GList ges_timeline_get_layers(GESTimeline timeline);

    GESTrack ges_timeline_get_track_for_pad(GESTimeline timeline, Pad pad);

    Pad ges_timeline_get_pad_for_track(GESTimeline timeline, GESTrack track);

    ClockTime ges_timeline_get_duration(GESTimeline timeline);

    boolean ges_timeline_get_auto_transition(GESTimeline timeline);

    void ges_timeline_set_auto_transition(GESTimeline timeline, boolean auto_transition);

    ClockTime ges_timeline_get_snapping_distance(GESTimeline timeline);

    void ges_timeline_set_snapping_distance(GESTimeline timeline, ClockTime snapping_distance);

    GESTimelineElement ges_timeline_get_element(GESTimeline timeline, String name);

    boolean ges_timeline_is_empty(GESTimeline timeline);
}
