
package org.gstreamer.lowlevel;

import org.gstreamer.ClockTime;
import org.gstreamer.GObject;
import org.gstreamer.ges.GESTimeline;
import org.gstreamer.ges.GESTimelineElement;
import org.gstreamer.ges.GESTrackType;
import org.gstreamer.lowlevel.GObjectAPI.GParamSpec;
import org.gstreamer.lowlevel.GValueAPI.GValue;
import org.gstreamer.lowlevel.annotations.FreeReturnValue;

import com.sun.jna.Library;
import com.sun.jna.Pointer;

public interface GESTimelineElementAPI extends Library {
    GESTimelineElementAPI GESTIMELINELEMENT_API = GstNative.load("ges", GESTimelineElementAPI.class);

    boolean
    ges_timeline_element_set_parent (GESTimelineElement self,GESTimelineElement parent);
    
    GESTimelineElement 
    ges_timeline_element_get_parent (GESTimelineElement self);
    
    boolean
    ges_timeline_element_set_timeline (GESTimelineElement self,
                                       GESTimeline timeline);
    
    GESTimeline
    ges_timeline_element_get_timeline (GESTimelineElement self);
    
    void
    ges_timeline_element_set_start (GESTimelineElement self,
                                    ClockTime start);
    
    void
    ges_timeline_element_set_inpoint (GESTimelineElement self,
                                      ClockTime inpoint);

    void ges_timeline_element_set_duration(GESTimelineElement self, ClockTime duration);
    
    void
    ges_timeline_element_set_max_duration (GESTimelineElement self,
                                           ClockTime maxduration);
    
    void
    ges_timeline_element_set_priority (GESTimelineElement self,int priority);
    
    ClockTime
    ges_timeline_element_get_start (GESTimelineElement self);
    
    ClockTime
    ges_timeline_element_get_inpoint (GESTimelineElement self);
    
    ClockTime
    ges_timeline_element_get_duration (GESTimelineElement self);
    
    ClockTime
    ges_timeline_element_get_max_duration (GESTimelineElement self);
    
    int ges_timeline_element_get_priority (GESTimelineElement self);
    
    boolean
    ges_timeline_element_ripple (GESTimelineElement self,
                                 ClockTime start);
    
    boolean
    ges_timeline_element_ripple_end (GESTimelineElement self,
                                     ClockTime end);
    
    boolean
    ges_timeline_element_roll_start (GESTimelineElement self,
                                     ClockTime start);
    
    boolean
    ges_timeline_element_roll_end (GESTimelineElement self,
                                   ClockTime end);
    
    boolean
    ges_timeline_element_trim (GESTimelineElement self,
                               ClockTime start);
    
    GESTimelineElement  ges_timeline_element_get_toplevel_parent(GESTimelineElement self);
    
    GESTimelineElement
    ges_timeline_element_copy (GESTimelineElement self,
                               boolean deep);

    GESTimelineElement
    ges_timeline_element_paste (GESTimelineElement self,
                                ClockTime paste_position);
    
    @FreeReturnValue
    Pointer
    ptr_ges_timeline_element_get_name (GESTimelineElement self);
    
    boolean
    ges_timeline_element_set_name (GESTimelineElement self,
                                   String name);
    
    GParamSpec []
    ges_timeline_element_list_children_properties
                                   (GESTimelineElement self,
                                    int n_properties);
    
    boolean
    ges_timeline_element_lookup_child (GESTimelineElement self,
                                       String prop_name,
                                       GObject child[],
                                       GParamSpec pspec[]);
    
    boolean
    ges_timeline_element_set_child_property
                                   (GESTimelineElement self,
                                    String property_name,
                                    GValue value);
    
    boolean
    ges_timeline_element_get_child_property
                                   (GESTimelineElement self,
                                    String property_name,
                                    GValue value);
    
    boolean
    ges_timeline_element_add_child_property
                                   (GESTimelineElement self,
                                    GParamSpec pspec,
                                    GObject child);
    
    boolean
    ges_timeline_element_remove_child_property
                                   (GESTimelineElement self,
                                    GParamSpec pspec);
    
    int 
    ges_timeline_element_get_track_types (GESTimelineElement self);
}
