package org.gstreamer.lowlevel;

import org.gstreamer.Element;
import org.gstreamer.ges.GESTrack;
import org.gstreamer.ges.GESTrackElement;
import org.gstreamer.lowlevel.GValueAPI.GValue;

import com.sun.jna.Library;

public interface GESTrackElementAPI extends Library {
    public static GESTrackElementAPI ges = GstNative.load("ges", GESTrackElementAPI.class);

    boolean ges_track_element_set_active(GESTrackElement object, boolean active);

    GESTrack ges_track_element_get_track(GESTrackElement object);

    Element ges_track_element_get_nleobject(GESTrackElement object);

    Element ges_track_element_get_gnlobject(GESTrackElement object);

    Element ges_track_element_get_element(GESTrackElement object);

    boolean ges_track_element_is_active(GESTrackElement object);

    // TODO: implement
    // boolean ges_track_element_lookup_child (GESTrackElement *object,
    // const gchar *prop_name,
    // GstElement **element,
    // GParamSpec **pspec);

    // TODO:implement
    // GParamSpec **
    // ges_track_element_list_children_properties
    // (GESTrackElement *object,
    // guint *n_properties);

    boolean ges_track_element_set_child_property(GESTrackElement object, String property_name, GValue value);

    void ges_track_element_set_child_properties(GESTrackElement object, Object... first_property_name);

    // TODO:implement
    // void
    // ges_track_element_set_child_property_by_pspec
    // (GESTrackElement *object,
    // GParamSpec *pspec,
    // GValue *value);

    boolean ges_track_element_get_child_property(GESTrackElement object, String property_name, GValue value);

    void ges_track_element_get_child_properties(GESTrackElement object, Object... first_property_name);

    // TODO:implement
    // void ges_track_element_get_child_property_by_pspec (GESTrackElement
    // object,GParamSpec pspec,GValue value);

    // TODO:implement
    // boolean ges_track_element_edit (GESTrackElement object,
    // GList layers,
    // GESEditMode mode,
    // GESEdge edge,
    // guint64 position);

    // TODO: implement
    // boolean ges_track_element_set_control_source (GESTrackElement object,
    // GstControlSource source,
    // String property_name,
    // char binding_type);

    // TODO:implement
    // GstControlBinding *
    // ges_track_element_get_control_binding (GESTrackElement *object,
    // const gchar *property_name);
}
