package org.gstreamer.lowlevel;

import org.gstreamer.ClockTime;
import org.gstreamer.discoverer.GstDiscovererInfo;
import org.gstreamer.ges.GESUriClipAsset;
import org.gstreamer.ges.GESUriClipAssetClass;
import org.gstreamer.lowlevel.GlibAPI.GList;
import org.gstreamer.lowlevel.GstAPI.GstCallback;

import com.sun.jna.Library;
import com.sun.jna.Pointer;


public interface GESUriClipAssetAPI extends Library {

    GType ges_uri_clip_asset_get_type();
    ClockTime ges_uri_clip_asset_get_duration (GESUriClipAsset self);
    boolean ges_uri_clip_asset_is_image (GESUriClipAsset self);
    GstDiscovererInfo  ges_uri_clip_asset_get_info (final GESUriClipAsset self);

    void ges_uri_clip_asset_new(String uri, GCancellable cancellable, GstCallback callback, Pointer user_data);

    Pointer ges_uri_clip_asset_request_sync(String uri, Pointer[] error);

    GList ges_uri_clip_asset_get_stream_assets(GESUriClipAsset self);

    void ges_uri_clip_asset_class_set_timeout(GESUriClipAssetClass klass, ClockTime timeout);
};
