package org.gstreamer.lowlevel;

import org.gstreamer.ges.GESVideoStandardTransitionType;
import org.gstreamer.ges.operation.GESVideoTransition;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Library;
import com.sun.jna.Pointer;

public interface GESVideoTransitionAPI extends Library {
    static GESVideoTransitionAPI GESVIDEOTRANSITION_API = GstNative.load("ges", GESVideoTransitionAPI.class);

    @CallerOwnsReturn
    Pointer ptr_ges_video_transition_new();

    @CallerOwnsReturn
    GESVideoTransition ges_video_transition_new();

    GESVideoStandardTransitionType ges_video_transition_get_transition_type(GESVideoTransition trans);

    void ges_video_transition_set_border(GESVideoTransition self, int value);

    int ges_video_transition_get_border(GESVideoTransition self);

    void ges_video_transition_set_inverted(GESVideoTransition self, boolean inverted);

    boolean ges_video_transition_is_inverted(GESVideoTransition self);

    boolean ges_video_transition_set_transition_type(GESVideoTransition self, GESVideoStandardTransitionType type);
}
