/**
 */

package org.gstreamer.lowlevel;

import java.util.Arrays;
import java.util.List;

import org.gstreamer.Caps;
import org.gstreamer.ClockTime;
import org.gstreamer.discoverer.Discoverer;
import org.gstreamer.discoverer.DiscovererResult;
import org.gstreamer.discoverer.GstDiscovererAudioInfo;
import org.gstreamer.discoverer.GstDiscovererContainerInfo;
import org.gstreamer.discoverer.GstDiscovererInfo;
import org.gstreamer.lowlevel.GlibAPI.GList;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Pointer;

/**
 * GstSample functions
 */
public interface GstDiscovererAPI extends com.sun.jna.Library {


    @CallerOwnsReturn
    Pointer ptr_gst_discoverer_new(ClockTime timeout, Pointer[] err);
    @CallerOwnsReturn
    Discoverer gst_discoverer_new(ClockTime timeout, Pointer[] err);

    void gst_discoverer_start(Discoverer discoverer);

    void gst_discoverer_stop(Discoverer discoverer);

    GstDiscovererInfo gst_discoverer_discover_uri(Discoverer discoverer, String uri, Pointer[] err);

    boolean gst_discoverer_discover_uri_async(Discoverer discoverer, String uri);

    ClockTime gst_discoverer_info_get_duration(GstDiscovererInfo info);

    DiscovererResult gst_discoverer_info_get_result(GstDiscovererInfo info);

    public static final class GstDiscovererStreamInfo extends com.sun.jna.Structure {
        @Override
        protected List<String> getFieldOrder() {
            return Arrays.asList(new String[] {});
        }
    }

    GstDiscovererStreamInfo gst_discoverer_info_get_stream_info(GstDiscovererInfo info);

    GList gst_discoverer_info_get_stream_list(GstDiscovererInfo info);

    // TODO: implement TagList
    // TagList gst_discoverer_info_get_tags(DiscovererInfo info);

    // TODO: iomplement Toc
    // const GstToc *
    // gst_discoverer_info_get_toc (const GstDiscovererInfo *info);

    String gst_discoverer_info_get_uri(GstDiscovererInfo info);

    boolean gst_discoverer_info_get_seekable(GstDiscovererInfo info);

    // TODO: implement
    // GVariant gst_discoverer_info_to_variant (GstDiscovererInfo *info,
    // GstDiscovererSerializeFlags flags);

    // TODO: iomplement
    // GstDiscovererInfo *
    // gst_discoverer_info_from_variant (GVariant *variant);

    Caps gst_discoverer_stream_info_get_caps(GstDiscovererStreamInfo info);

    GstDiscovererStreamInfo gst_discoverer_stream_info_get_next(GstDiscovererStreamInfo info);

    GstDiscovererStreamInfo gst_discoverer_stream_info_get_previous(GstDiscovererStreamInfo info);

    // TODO:implement
    // const GstTagList *
    // gst_discoverer_stream_info_get_tags (GstDiscovererStreamInfo *info);

    // TODO:implement
    // const GstToc *
    // gst_discoverer_stream_info_get_toc (GstDiscovererStreamInfo *info);

    String gst_discoverer_stream_info_get_stream_id(GstDiscovererStreamInfo info);

    void gst_discoverer_stream_info_list_free(GList infos);

    String gst_discoverer_stream_info_get_stream_type_nick(GstDiscovererStreamInfo info);

    // TODO: check if String array is ok
    String[] gst_discoverer_info_get_missing_elements_installer_details(GstDiscovererInfo info);

    GList gst_discoverer_info_get_audio_streams(GstDiscovererInfo info);

    GList gst_discoverer_info_get_container_streams(GstDiscovererInfo info);

    GList gst_discoverer_info_get_streams(GstDiscovererInfo info, GType streamtype);

    GList gst_discoverer_info_get_subtitle_streams(GstDiscovererInfo info);

    GList gst_discoverer_info_get_video_streams(GstDiscovererInfo info);

    int gst_discoverer_audio_info_get_bitrate(GstDiscovererAudioInfo info);

    int gst_discoverer_audio_info_get_channels(GstDiscovererAudioInfo info);

    int gst_discoverer_audio_info_get_depth(GstDiscovererAudioInfo info);

    String gst_discoverer_audio_info_get_language(GstDiscovererAudioInfo info);

    int gst_discoverer_audio_info_get_max_bitrate(GstDiscovererAudioInfo info);

    int gst_discoverer_audio_info_get_sample_rate(GstDiscovererAudioInfo info);

    GList gst_discoverer_container_info_get_streams(GstDiscovererContainerInfo info);

    public static final class GstDiscovererSubtitleInfo extends com.sun.jna.Structure {
        @Override
        protected List<String> getFieldOrder() {
            return Arrays.asList(new String[] {});
        }
    }
    String gst_discoverer_subtitle_info_get_language(GstDiscovererSubtitleInfo info);

    public static final class GstDiscovererVideoInfo extends com.sun.jna.Structure {
        @Override
        protected List<String> getFieldOrder() {
            return Arrays.asList(new String[] {});
        }
    }
    int gst_discoverer_video_info_get_bitrate(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_depth(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_framerate_denom(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_framerate_num(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_height(GstDiscovererVideoInfo info);

    boolean gst_discoverer_video_info_is_interlaced(GstDiscovererVideoInfo info);

    boolean gst_discoverer_video_info_is_image(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_max_bitrate(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_par_denom(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_par_num(GstDiscovererVideoInfo info);

    int gst_discoverer_video_info_get_width(GstDiscovererVideoInfo info);
}
