/**
 */

package org.gstreamer.lowlevel;

import org.gstreamer.Caps;
import org.gstreamer.discoverer.GstDiscovererInfo;
import org.gstreamer.encoding.EncodingAudioProfile;
import org.gstreamer.encoding.EncodingContainerProfile;
import org.gstreamer.encoding.EncodingProfile;
import org.gstreamer.encoding.EncodingTarget;
import org.gstreamer.encoding.EncodingVideoProfile;
import org.gstreamer.lowlevel.GlibAPI.GList;
import org.gstreamer.lowlevel.annotations.CallerOwnsReturn;

import com.sun.jna.Pointer;

/**
 * GstSample functions
 */
public interface GstEncodingProfileAPI extends com.sun.jna.Library {
    static GstEncodingProfileAPI GSTENCODINGPROFILE_API = GstNative.load("gstpbutils", GstEncodingProfileAPI.class);

    @CallerOwnsReturn
    Pointer ptr_gst_encoding_profile_find(String targetname, String profilename, String category);

    @CallerOwnsReturn
    EncodingProfile gst_encoding_profile_find(String targetname, String profilename, String category);

    @CallerOwnsReturn
    Pointer ptr_gst_encoding_profile_from_discoverer(GstDiscovererInfo info);

    @CallerOwnsReturn
    EncodingProfile gst_encoding_profile_from_discoverer(GstDiscovererInfo info);

    String gst_encoding_profile_get_name(EncodingProfile profile);

    String gst_encoding_profile_get_description(EncodingProfile profile);

    Caps gst_encoding_profile_get_format(EncodingProfile profile);

    String gst_encoding_profile_get_preset(EncodingProfile profile);

    String gst_encoding_profile_get_preset_name(EncodingProfile profile);

    int gst_encoding_profile_get_presence(EncodingProfile profile);

    Caps gst_encoding_profile_get_restriction(EncodingProfile profile);

    String gst_encoding_profile_get_file_extension(EncodingProfile profile);

    void gst_encoding_profile_set_name(EncodingProfile profile, String name);

    void gst_encoding_profile_set_description(EncodingProfile profile, String description);

    void gst_encoding_profile_set_enabled(EncodingProfile profile, boolean enabled);

    void gst_encoding_profile_set_format(EncodingProfile profile, Caps format);

    void gst_encoding_profile_set_preset(EncodingProfile profile, String preset);

    void gst_encoding_profile_set_preset_name(EncodingProfile profile, String preset_name);

    void gst_encoding_profile_set_restriction(EncodingProfile profile, Caps restriction);

    void gst_encoding_profile_set_presence(EncodingProfile profile, int presence);

    boolean gst_encoding_profile_is_equal(EncodingProfile a, EncodingProfile b);

    boolean gst_encoding_profile_is_enabled(EncodingProfile profile);

    Caps gst_encoding_profile_get_input_caps(EncodingProfile profile);

    String gst_encoding_profile_get_type_nick(EncodingProfile profile);

    @CallerOwnsReturn
    Pointer ptr_gst_encoding_container_profile_new(String name, String description, Caps format, String preset);

    EncodingContainerProfile gst_encoding_container_profile_new(String name, String description, Caps format,
            String preset);

    boolean gst_encoding_container_profile_add_profile(EncodingContainerProfile container, EncodingProfile profile);

    boolean gst_encoding_container_profile_contains_profile(EncodingContainerProfile container,
            EncodingProfile profile);

    GList gst_encoding_container_profile_get_profiles(EncodingContainerProfile profile);

    @CallerOwnsReturn
    Pointer ptr_gst_encoding_audio_profile_new(Caps format, String preset, Caps restrictoin, int presence);

    EncodingAudioProfile gst_encoding_audio_profile_new(Caps format, String preset, Caps restriction, int presence);

    @CallerOwnsReturn
    Pointer ptr_gst_encoding_video_profile_new(Caps format, String preset, Caps restrictoin, int presence);

    EncodingVideoProfile gst_encoding_video_profile_new(Caps format, String preset, Caps restriction, int presence);

    int gst_encoding_video_profile_get_pass(EncodingVideoProfile prof);

    boolean gst_encoding_video_profile_get_variableframerate(EncodingVideoProfile prof);

    void gst_encoding_video_profile_set_pass(EncodingVideoProfile prof, int pass);

    void gst_encoding_video_profile_set_variableframerate(EncodingVideoProfile prof, boolean variableframerate);

    EncodingTarget gst_encoding_target_new(String name, String category, String description, GList profiles);

    String gst_encoding_target_get_name(EncodingTarget target);

    String gst_encoding_target_get_category(EncodingTarget target);

    String gst_encoding_target_get_description(EncodingTarget target);

    GList gst_encoding_target_get_profiles(EncodingTarget target);

    EncodingProfile gst_encoding_target_get_profile(EncodingTarget target, String name);

    boolean gst_encoding_target_add_profile(EncodingTarget target, EncodingProfile profile);

    boolean gst_encoding_target_save(EncodingTarget target, Pointer[] error);

    boolean gst_encoding_target_save_to_file(EncodingTarget target, String filepath, Pointer[] error);

    EncodingTarget gst_encoding_target_load(String name, String category, Pointer[] error);

    EncodingTarget gst_encoding_target_load_from_file(String filepath, Pointer[] error);

    GList gst_encoding_list_all_targets(String categoryname);

    GList gst_encoding_list_available_categories();
}
